module Diagram (Endpoints : Endpoints) (ContentsLattice : ContentsLattice) =
struct
  type t

  let print fmt av = raise (NotImplemented "Lattice")
  let bottom () = raise (NotImplemented "Lattice")
  let top () = raise (NotImplemented "Lattice")
  let is_bottom av = raise (NotImplemented "Lattice")
  let is_leq av1 av2 = raise (NotImplemented "Lattice")
  let join av1 av2 = raise (NotImplemented "Lattice")
  let join_list av_list = raise (NotImplemented "Lattice")
  let meet av1 av2 = raise (NotImplemented "Lattice")
  let meet_list av_list = raise (NotImplemented "Lattice")
  let canonical av = raise (NotImplemented "Lattice")
  let widening av1 av2 = raise (NotImplemented "Lattice")

  module Semantics =
  struct
    module Guard =
    struct
      type t
      let from_guard guard = raise (NotImplemented "Lattice")
    end

    module Command =
    struct
      type t
      let from_command command = raise (NotImplemented "Lattice")
    end

    let apply_guard av guard = raise (NotImplemented "Lattice")
    let apply_command av command = raise (NotImplemented "Lattice")
  end

  let constraints av = raise (NotImplemented "Lattice")
  let from_constraints c = raise (NotImplemented "Lattice")
end
