model insertion_sort {

var i, j, k, n;
array A;

states init, loop, aff_key, loop_sort, cond_sort, aff_sort, end_sort, aff_end_sort, final;

transition t1 := {
   from   := init;
   to     := loop;
   guard  := n>0;
   action := i'=2;
};

transition t2 := {
   from   := loop;
   to     := aff_key;
   guard  := i<=n;
   action := k'=A[i];
};

transition t3 := {
   from   := aff_key;
   to     := loop_sort;
   guard  := true;
   action := j'=i-1;
};

transition t4 := {
   from   := loop_sort;
   to     := cond_sort;
   guard  := j>=1;
};

transition t5 := {
   from   := cond_sort;
   to     := aff_sort;
   guard  := A[j]>k;
   action := A[j+1]'=A[j];
};

transition t6 := {
   from   := aff_sort;
   to     := loop_sort;
   guard  := true;
   action := j'=j-1;
};

transition t7 := {
   from   := cond_sort;
   to     := end_sort;
   guard  := A[j]<=k;
};

transition t8 := {
   from   := loop_sort;
   to     := end_sort;
   guard  := j<1;
};

transition t9 := {
   from   := end_sort;
   to     := aff_end_sort;
   guard  := true;
   action := A[j+1]'=k;
};

transition t10 := {
   from   := aff_end_sort;
   to     := loop;
   guard  := true;
   action  := i'=i+1;
};

transition t11 := {
   from   := loop;
   to     := final;
   guard  := i>n;
};

}

strategy s1 {

Region init := {
state=init
};

}